/* preferences_dialog.c generated by valac 0.56.16, the Vala compiler
 * generated from preferences_dialog.vala, do not modify */

/*
 * This file is part of GNOME LaTeX.
 *
 * Copyright © 2010-2022 Sébastien Wilmet
 *
 * GNOME LaTeX is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME LaTeX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME LaTeX.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tepl/tepl.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <latexila.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN void preferences_dialog_fill (TeplPrefsDialog* prefs_dialog);
VALA_EXTERN void preferences_dialog_reset_all (void);
static void _preferences_dialog_reset_all_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static void
_preferences_dialog_reset_all_gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 30 "preferences_dialog.vala"
	preferences_dialog_reset_all ();
#line 72 "preferences_dialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "preferences_dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 80 "preferences_dialog.c"
}

void
preferences_dialog_fill (TeplPrefsDialog* prefs_dialog)
{
	GtkButton* reset_button = NULL;
	GtkButton* _tmp0_;
	GtkHeaderBar* headerbar = NULL;
	GtkHeaderBar* _tmp1_;
	GtkHeaderBar* _tmp2_;
	GtkBox* content_area = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkNotebook* _tmp5_;
#line 24 "preferences_dialog.vala"
	g_return_if_fail (prefs_dialog != NULL);
#line 27 "preferences_dialog.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_mnemonic (_ ("_Reset All"));
#line 27 "preferences_dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 27 "preferences_dialog.vala"
	reset_button = _tmp0_;
#line 28 "preferences_dialog.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) reset_button, _ ("Reset all preferences"));
#line 29 "preferences_dialog.vala"
	gtk_widget_show_all ((GtkWidget*) reset_button);
#line 30 "preferences_dialog.vala"
	g_signal_connect (reset_button, "clicked", (GCallback) _preferences_dialog_reset_all_gtk_button_clicked, NULL);
#line 31 "preferences_dialog.vala"
	_tmp1_ = gtk_dialog_get_header_bar ((GtkDialog*) prefs_dialog);
#line 31 "preferences_dialog.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_header_bar_get_type ()) ? ((GtkHeaderBar*) _tmp1_) : NULL);
#line 31 "preferences_dialog.vala"
	headerbar = _tmp2_;
#line 32 "preferences_dialog.vala"
	gtk_header_bar_pack_start (headerbar, (GtkWidget*) reset_button);
#line 35 "preferences_dialog.vala"
	_tmp3_ = gtk_dialog_get_content_area ((GtkDialog*) prefs_dialog);
#line 35 "preferences_dialog.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gtk_box_get_type ()) ? ((GtkBox*) _tmp3_) : NULL);
#line 35 "preferences_dialog.vala"
	content_area = _tmp4_;
#line 36 "preferences_dialog.vala"
	_tmp5_ = latexila_prefs_create_notebook ();
#line 36 "preferences_dialog.vala"
	gtk_box_pack_start (content_area, (GtkWidget*) _tmp5_, TRUE, TRUE, (guint) 0);
#line 24 "preferences_dialog.vala"
	_g_object_unref0 (content_area);
#line 24 "preferences_dialog.vala"
	_g_object_unref0 (headerbar);
#line 24 "preferences_dialog.vala"
	_g_object_unref0 (reset_button);
#line 133 "preferences_dialog.c"
}

void
preferences_dialog_reset_all (void)
{
	TeplPrefsDialog* prefs_dialog = NULL;
	TeplPrefsDialog* _tmp0_;
	TeplPrefsDialog* _tmp1_;
	GtkDialog* dialog = NULL;
	TeplPrefsDialog* _tmp2_;
	GtkMessageDialog* _tmp3_;
	GtkDialog* _tmp4_;
	GtkDialog* _tmp5_;
	gint resp = 0;
	GtkDialog* _tmp6_;
	GtkDialog* _tmp7_;
	gchar** settings_str = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gint settings_str_length1;
	gint _settings_str_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
#line 41 "preferences_dialog.vala"
	_tmp0_ = tepl_prefs_dialog_get_singleton ();
#line 41 "preferences_dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 41 "preferences_dialog.vala"
	prefs_dialog = _tmp1_;
#line 43 "preferences_dialog.vala"
	_tmp2_ = prefs_dialog;
#line 43 "preferences_dialog.vala"
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) _tmp2_, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "%s", _ ("Do you really want to reset all preferences?"));
#line 43 "preferences_dialog.vala"
	g_object_ref_sink (_tmp3_);
#line 43 "preferences_dialog.vala"
	dialog = (GtkDialog*) _tmp3_;
#line 47 "preferences_dialog.vala"
	_tmp4_ = dialog;
#line 47 "preferences_dialog.vala"
	gtk_dialog_add_button (_tmp4_, _ ("_Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 48 "preferences_dialog.vala"
	_tmp5_ = dialog;
#line 48 "preferences_dialog.vala"
	gtk_dialog_add_button (_tmp5_, _ ("_Reset All"), (gint) GTK_RESPONSE_YES);
#line 50 "preferences_dialog.vala"
	_tmp6_ = dialog;
#line 50 "preferences_dialog.vala"
	resp = gtk_dialog_run (_tmp6_);
#line 51 "preferences_dialog.vala"
	_tmp7_ = dialog;
#line 51 "preferences_dialog.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp7_);
#line 52 "preferences_dialog.vala"
	if (resp != ((gint) GTK_RESPONSE_YES)) {
#line 53 "preferences_dialog.vala"
		_g_object_unref0 (dialog);
#line 53 "preferences_dialog.vala"
		_g_object_unref0 (prefs_dialog);
#line 53 "preferences_dialog.vala"
		return;
#line 196 "preferences_dialog.c"
	}
#line 55 "preferences_dialog.vala"
	_tmp8_ = g_strdup ("org.gnome.gnome-latex.preferences.editor");
#line 55 "preferences_dialog.vala"
	_tmp9_ = g_strdup ("org.gnome.gnome-latex.preferences.latex");
#line 55 "preferences_dialog.vala"
	_tmp10_ = g_new0 (gchar*, 2 + 1);
#line 55 "preferences_dialog.vala"
	_tmp10_[0] = _tmp8_;
#line 55 "preferences_dialog.vala"
	_tmp10_[1] = _tmp9_;
#line 55 "preferences_dialog.vala"
	settings_str = _tmp10_;
#line 55 "preferences_dialog.vala"
	settings_str_length1 = 2;
#line 55 "preferences_dialog.vala"
	_settings_str_size_ = settings_str_length1;
#line 61 "preferences_dialog.vala"
	_tmp11_ = settings_str;
#line 61 "preferences_dialog.vala"
	_tmp11__length1 = settings_str_length1;
#line 218 "preferences_dialog.c"
	{
		gchar** setting_str_collection = NULL;
		gint setting_str_collection_length1 = 0;
		gint _setting_str_collection_size_ = 0;
		gint setting_str_it = 0;
#line 61 "preferences_dialog.vala"
		setting_str_collection = _tmp11_;
#line 61 "preferences_dialog.vala"
		setting_str_collection_length1 = _tmp11__length1;
#line 61 "preferences_dialog.vala"
		for (setting_str_it = 0; setting_str_it < setting_str_collection_length1; setting_str_it = setting_str_it + 1) {
#line 230 "preferences_dialog.c"
			gchar* _tmp12_;
			gchar* setting_str = NULL;
#line 61 "preferences_dialog.vala"
			_tmp12_ = g_strdup (setting_str_collection[setting_str_it]);
#line 61 "preferences_dialog.vala"
			setting_str = _tmp12_;
#line 237 "preferences_dialog.c"
			{
				GSettings* settings = NULL;
				const gchar* _tmp13_;
				GSettings* _tmp14_;
				gchar** keys = NULL;
				GSettings* _tmp15_;
				gchar** _tmp16_;
				gchar** _tmp17_;
				gint keys_length1;
				gint _keys_size_;
				gchar** _tmp18_;
				gint _tmp18__length1;
#line 63 "preferences_dialog.vala"
				_tmp13_ = setting_str;
#line 63 "preferences_dialog.vala"
				_tmp14_ = g_settings_new (_tmp13_);
#line 63 "preferences_dialog.vala"
				settings = _tmp14_;
#line 64 "preferences_dialog.vala"
				_tmp15_ = settings;
#line 64 "preferences_dialog.vala"
				_tmp17_ = _tmp16_ = g_settings_list_keys (_tmp15_);
#line 64 "preferences_dialog.vala"
				keys = _tmp17_;
#line 64 "preferences_dialog.vala"
				keys_length1 = _vala_array_length (_tmp16_);
#line 64 "preferences_dialog.vala"
				_keys_size_ = keys_length1;
#line 65 "preferences_dialog.vala"
				_tmp18_ = keys;
#line 65 "preferences_dialog.vala"
				_tmp18__length1 = keys_length1;
#line 270 "preferences_dialog.c"
				{
					gchar** key_collection = NULL;
					gint key_collection_length1 = 0;
					gint _key_collection_size_ = 0;
					gint key_it = 0;
#line 65 "preferences_dialog.vala"
					key_collection = _tmp18_;
#line 65 "preferences_dialog.vala"
					key_collection_length1 = _tmp18__length1;
#line 65 "preferences_dialog.vala"
					for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 282 "preferences_dialog.c"
						gchar* _tmp19_;
						gchar* key = NULL;
#line 65 "preferences_dialog.vala"
						_tmp19_ = g_strdup (key_collection[key_it]);
#line 65 "preferences_dialog.vala"
						key = _tmp19_;
#line 289 "preferences_dialog.c"
						{
							GSettings* _tmp20_;
							const gchar* _tmp21_;
#line 66 "preferences_dialog.vala"
							_tmp20_ = settings;
#line 66 "preferences_dialog.vala"
							_tmp21_ = key;
#line 66 "preferences_dialog.vala"
							g_settings_reset (_tmp20_, _tmp21_);
#line 65 "preferences_dialog.vala"
							_g_free0 (key);
#line 301 "preferences_dialog.c"
						}
					}
				}
#line 61 "preferences_dialog.vala"
				keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 61 "preferences_dialog.vala"
				_g_object_unref0 (settings);
#line 61 "preferences_dialog.vala"
				_g_free0 (setting_str);
#line 311 "preferences_dialog.c"
			}
		}
	}
#line 39 "preferences_dialog.vala"
	settings_str = (_vala_array_free (settings_str, settings_str_length1, (GDestroyNotify) g_free), NULL);
#line 39 "preferences_dialog.vala"
	_g_object_unref0 (dialog);
#line 39 "preferences_dialog.vala"
	_g_object_unref0 (prefs_dialog);
#line 321 "preferences_dialog.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 27 "build_tools_preferences.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 331 "preferences_dialog.c"
		gssize i;
#line 27 "build_tools_preferences.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 27 "build_tools_preferences.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 27 "build_tools_preferences.vala"
				destroy_func (((gpointer*) array)[i]);
#line 339 "preferences_dialog.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 27 "build_tools_preferences.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 27 "build_tools_preferences.vala"
	g_free (array);
#line 354 "preferences_dialog.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 27 "build_tools_preferences.vala"
	if (array) {
#line 27 "build_tools_preferences.vala"
		while (((gpointer*) array)[length]) {
#line 27 "build_tools_preferences.vala"
			length++;
#line 368 "preferences_dialog.c"
		}
	}
#line 27 "build_tools_preferences.vala"
	return length;
#line 373 "preferences_dialog.c"
}

